package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.teams;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.core.util.text.DisconnectInfo;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.AsyncPlayerPreLoginEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;

class ConnectivityChangeListener extends ApplianceListener<Teams> {
    @EventHandler
    public void onLogin(AsyncPlayerPreLoginEvent event) {
        boolean result = this.getAppliance().canLogin(event.getUniqueId());
        event.kickMessage(new DisconnectInfo(
            "Kein Teilnehmer",
            "Du bist nicht als Teilnehmer registriert oder bist ausgeschieden!",
            "Sollte dies ein Fehler sein, kontaktiere bitte einen Admin.",
            event.getUniqueId()
        ).getComponent());
        if(!result) event.setLoginResult(AsyncPlayerPreLoginEvent.Result.KICK_OTHER);
    }

    @EventHandler
    public void onJoin(PlayerJoinEvent event) {
        this.getAppliance().enforceTeamJoin(event.getPlayer());
    }

    @EventHandler
    public void onLeave(PlayerQuitEvent event) {
        this.getAppliance().enforceTeamLeave(event.getPlayer());
    }
}
